# Queue [ C ]

## Usage

Create a new Queue object

```c
Queue_Char_s* my_queue = new_Char_queue();
```

A newly created is completely empty, a new queue node is not created until the first enqueue command is called.
```c
//Enqueue value to queue (add to Queue)
enqueue(my_queue, 'c');

//Dequeue vaule from queue (remove from Queue)
char foo = dequeue(my_queue);

//Peek at the front of the queue, without removing
char foo = peek(my_queue);

//Check size of queue or if queue is empty 
size_t size = my_queue->size;
bool bar = is_empty(my_queue);

//Delete queue
delete(my_queue);
```
---

## Examples

Coming soon..

---

## Building New Queue Types
The basic queue consists of the following sections
  
  **1. New Queue Node**

The queue nodes are dynamically linked at one point, meaning information can only pass in one direction. Node A points to Node B, but  Node B does not know about Node A.
  
  *queue.h*
  ```c
  static struct Node_name_s* new_node_name(void)
  static struct Node_name_s{
    struct Node_name_s* next;
    <data_type> val;
  }Node_name_s
  ```
  *queue.c*
  ```c
  static struct Node_name_s* new_node_name(void){
    struct Node_name_s* self = NULL;

    self = (struct Node_name_s*)malloc(sizeof(struct Node_name_s));
    if(self == NULL){
      return NULL;
    }

    self->next = NULL;

    self->val = val;

    return self;
  }
  ```

  **2. New Queue object**

 The queue consists of two nodes, 4 function pointers and a size variable. The two nodes point to the front and back of the queue, and the size variable tracks how big the queue is. The function pointers are used to simplify the library API.
  
  *queue.h*
  ```c
  typedef stuct Queue_name_s Queue_name_s;
  Queue_name_s* new_name_queue(void);

  struct Queue_name_s{
    struct Node_name_s* front;
    struct Node_name_s* back;

    fptrEnqueue_name enqueue;
    fptrDequeue_name dequeue;
    fptrPeek_name peek;
    fptrIsEmpty_name is_empty;
    fptrDelete_name delete;
  }
  ```
  *queue.c*
  ```c
  Queue_name_s* new_name_queue(void){
    Queue_name_s* self = NULL;

    self = (Queue_name_s*)malloc(sizeof(Queue_name_s));
    if(self == NULL){
      return NULL;
    }

    self->front = NULL;
    self->back = NULL;

    self->size = 0;

    self->enqueue = &enqueue_name;
    self->dequeue = &dequeue_name;
    self->peek = &peek_name;
    self->isEmpty = &is_empty_name;
    self->delete = &delete_name;

    return self;
  }
  ```

  **3. Enqueue function**
  
  *queue.h*
  ```c
  typedef void (*fptrEnqueue_name)(Queue_name_s*, <data_type>));
  static void enqueue_name(Queue_name_s*, <data_type>); 
  ```
  *queue.c*
  ```c
  static void enqueue_name(Queue_name_s* self, <data_type> val){
    if(is_empty_name(self)){
      self->front = new_name_node(val);
      self->back = self->front;
    }

    else{
      self->back->next = new_name_node(val);
      self->back = self->back->next;
    }

    if(self->size < (size_t)-1){
      self->size++;
    }
    return;
}
  ```

  4. **Dequeue function**
  
  *queue.h*
  ```c
  typedef <data_type> (*fptrDequeue_name)(Queue_name_s*);
  static <data_type> dequeue_name(Queue_name_s*);
  ```
  *queue.c*
  ```c
  static <data_type> dequeue_name(Queue_name_s* self){  
    if(is_empty_name(self)){
      return 0;
    }

    struct Node_name_s* temp_node = NULL;

    <data_type> ret_val = self->front->val;

    temp_node = self->front->next;
    free(self->front);
    self->front = temp_node;

    if(is_empty_temp(self)){
      self->back = NULL;
    }

    if(self->size > 0){
      self->size--;
    }

    return ret_val;
  }
  ```
  **5. Peek Function**
  
  *queue.h*
  ```c
  typedef <data_type> (*fptrPeek_name)(Queue_name_s*);
  static <data_type> peek_name(Queue_name_s*); 
  ```
  *queue.c*
  ```c
  static <data_type> peek_name(Queue_name_s* self){
    if(is_empty_name(self)){
      return 0;
    }
    
    return self->front->val;
  }
  ```
  **6. Is_Empty function**
  
  *queue.h*
  ```c
  typedef bool (*fptrIsEmpty_name)(Queue_name_s*);
  static bool is_empty_name(Queue_name_s*); 
  ```
  *queue.c*
  ```c
  static bool is_empty_name(Queue_name_s* self){
    if(self->front == NULL){
      return true;
    }
    return false;
  }
  ```
  **7. Delete queue function**
  
  *queue.h*
  ```c
  typedef void (*fptrDelete_name)(Queue_name_s*);
  static void delete_name(Queue_name_s*);
  ```
  *queue.c*
  ```c
  static void delete_name(Queue_name_s* self){
    while(!is_empty_name(self)){
      dequeue(self);
    }
    
    return;
  }
  ```
---

  ## Testing
  Unit testing is done using the [Ceedling](https://github.com/ThrowTheSwitch/Ceedling) build system. The testing source code is in the **test/** directory and can be run using the Ceedling test command from the top level
  ```bash
  ceedling test:all
  ```

  [More info](https://libs2.gitlab.io/c/data-struct/queue/test.html)

### Requirments

- Ceedling
- Ruby
- GCC

---

  ## Documentation
  The source code documentation is autogenerated using the [Doxygen](https://www.doxygen.nl/index.html) documentation generator. To generate the documentation Doxygen tool on the *Doxyfile* from the top level
  ```bash
  doxygen Doyfile
  ```

  This command will populate the **docs/** folder with a LaTeX folder and an HTML folder that will contain the appropriate files. The generated HTML documentation can be found at the following [link](https://libs2.gitlab.io/c/data-struct/queue/)